Index: XIOS3/trunk/src/node/context.cpp
===================================================================
--- XIOS3/trunk/src/node/context.cpp	(revision 2546)
+++ XIOS3/trunk/src/node/context.cpp	(revision 2547)
@@ -34,4 +34,5 @@
 #include "services.hpp"
 #include "contexts_manager.hpp"
+#include "thread_manager.hpp"
 #include <chrono>
 #include <random>
@@ -488,8 +489,4 @@
       }
       contextId_ = getId() ;
-      
-      attached_mode=true ;
-      if (!CXios::isUsingServer()) attached_mode=false ;
-
 
       string contextRegistryId=getId() ;
@@ -544,5 +541,4 @@
     MPI_Comm_dup(intraComm_, &intraCommClient);
     comms.push_back(intraCommClient);
-    // attached_mode=parentServerContext_->isAttachedMode() ; //ym probably inherited from source context
 
     CContextServer* server ;
@@ -578,8 +574,10 @@
     if (commRank==0)
     {
-      CXios::getServicesManager()->getServiceNbPartitions(poolId, serverId, 0, nbPartitions, true) ;
-      for(int i=0 ; i<nbPartitions; i++) CXios::getContextsManager()->createServerContext(poolId, serverId, i, getContextId()) ;
-    }
-    setCurrent(getId()) ; // getCurrent/setCurrent may be supress, it can cause a lot of trouble (attached ???)
+      while (! CXios::getServicesManager()->getServiceNbPartitions(poolId, serverId, 0, nbPartitions)) yield() ;
+      for(int i=0 ; i<nbPartitions; i++)  
+        while (!CXios::getContextsManager()->createServerContext(poolId, serverId, i, getContextId())) yield() ;
+    }
+    synchronize() ;
+    setCurrent(getId()) ; // getCurrent/setCurrent may be supress, it can cause a lot of trouble 
     MPI_Bcast(&nbPartitions, 1, MPI_INT, 0, intraComm_) ;
       
@@ -587,8 +585,10 @@
     for(int i=0 ; i<nbPartitions; i++)
     {
-      parentServerContext_->createIntercomm(poolId, serverId, i, getContextId(), intraComm_, interCommClient, interCommServer) ;
+      while (!parentServerContext_->createIntercomm(poolId, serverId, i, getContextId(), intraComm_, interCommClient, interCommServer)) yield() ;
       int type ; 
-      if (commRank==0) CXios::getServicesManager()->getServiceType(poolId, serverId, 0, type, true) ;
+      if (commRank==0) while (!CXios::getServicesManager()->getServiceType(poolId, serverId, 0, type)) yield();
+      synchronize() ;
       MPI_Bcast(&type,1,MPI_INT,0,intraComm_) ;
+
       string fullServerId=CXios::getContextsManager()->getServerContextName(poolId, serverId, i, type, getContextId()) ;
 
@@ -620,6 +620,5 @@
     if (serviceType_ == CServicesManager::CLIENT)
     {
-      if (attached_mode) createServerInterComm(CClient::getPoolRessource()->getId(), getContextId()+"_"+CXios::defaultWriterId, clientServers) ;
-      else if (CXios::usingServer2) createServerInterComm(CXios::defaultPoolId, CXios::defaultGathererId, clientServers) ;
+      if (CXios::usingServer2) createServerInterComm(CXios::defaultPoolId, CXios::defaultGathererId, clientServers) ;
       else createServerInterComm(CXios::defaultPoolId, CXios::defaultWriterId, clientServers) ;
       
@@ -629,6 +628,5 @@
       clientServers.clear() ;
    
-      if (attached_mode) createServerInterComm(CClient::getPoolRessource()->getId(), getContextId()+"_"+CXios::defaultReaderId, clientServers) ;
-      else createServerInterComm(CXios::defaultPoolId, CXios::defaultReaderId, clientServers) ;
+      createServerInterComm(CXios::defaultPoolId, CXios::defaultReaderId, clientServers) ;
       readerClientOut_.push_back(clientServers[0].second.first) ; 
       readerServerOut_.push_back(clientServers[0].second.second) ;
@@ -658,10 +656,10 @@
     else
     {
-      if (attached_mode) createServerInterComm(CClient::getPoolRessource()->getId(), getContextId()+"_"+serviceId, retClientServers) ;
-      else createServerInterComm(poolId, serviceId, retClientServers) ;
+      createServerInterComm(poolId, serviceId, retClientServers) ;
       for(auto& retClientServer : retClientServers)  clientServers.push_back(retClientServer.second) ;
       
       int serviceType ;
-      if (intraCommRank_==0) CXios::getServicesManager()->getServiceType(poolId, serviceId, 0, serviceType, true) ;
+      if (intraCommRank_==0) while(!CXios::getServicesManager()->getServiceType(poolId, serviceId, 0, serviceType)) yield(); 
+      synchronize() ;
       MPI_Bcast(&serviceType,1,MPI_INT,0,intraComm_) ;
       
@@ -694,10 +692,48 @@
   void CContext::globalEventLoop(void)
   {
-    lockContext() ;
-    CXios::getDaemonsManager()->eventLoop() ;
-    unlockContext() ;
-    setCurrent(getId()) ;
+    if (CThreadManager::isUsingThreads()) CThreadManager::yield();
+    else
+    {
+      lockContext() ;
+      CXios::getDaemonsManager()->eventLoop() ;
+      unlockContext() ;
+      setCurrent(getId()) ;
+    }
   }
 
+  void CContext::yield(void)
+  {
+    if (CThreadManager::isUsingThreads()) 
+    {
+      CThreadManager::yield();
+      setCurrent(getId()) ;
+    }
+    else
+    {
+      lockContext() ;
+      CXios::getDaemonsManager()->eventLoop() ;
+      unlockContext() ;
+      setCurrent(getId()) ;
+    }
+  }
+
+  void CContext::synchronize(void)
+  {
+    bool out, finished; 
+    size_t timeLine=timeLine_ ;
+      
+    timeLine_++ ;
+    eventScheduler_->registerEvent(timeLine, hashId_) ;
+      
+    out = eventScheduler_->queryEvent(timeLine,hashId_) ;
+    if (out) eventScheduler_->popEvent() ;
+    while (!out)
+    {
+      yield() ;
+      out = eventScheduler_->queryEvent(timeLine,hashId_) ;
+      if (out) eventScheduler_->popEvent() ;
+    }
+  }
+  
   bool CContext::scheduledEventLoop(bool enableEventsProcessing) 
   {
@@ -761,10 +797,11 @@
        if (couplerOutClient_.find(fullContextId)==couplerOutClient_.end()) 
        {
-         bool ok=CXios::getContextsManager()->getContextLeader(fullContextId, contextLeader, getIntraComm()) ;
+         while(!CXios::getContextsManager()->getContextLeader(fullContextId, contextLeader, getIntraComm())) yield();
+         synchronize() ;
      
          MPI_Comm interComm, interCommClient, interCommServer  ;
          MPI_Comm intraCommClient, intraCommServer ;
 
-         if (ok) MPI_Intercomm_create(getIntraComm(), 0, CXios::getXiosComm(), contextLeader, 0, &interComm) ;
+         MPI_Intercomm_create(getIntraComm(), 0, CXios::getXiosComm(), contextLeader, 0, &interComm) ;
 
         MPI_Comm_dup(intraComm_, &intraCommClient) ;
@@ -783,10 +820,11 @@
     else if (couplerInClient_.find(fullContextId)==couplerInClient_.end())
     {
-      bool ok=CXios::getContextsManager()->getContextLeader(fullContextId, contextLeader, getIntraComm()) ;
+      while(!CXios::getContextsManager()->getContextLeader(fullContextId, contextLeader, getIntraComm())) yield() ;
+      synchronize() ;
      
        MPI_Comm interComm, interCommClient, interCommServer  ;
        MPI_Comm intraCommClient, intraCommServer ;
 
-       if (ok) MPI_Intercomm_create(getIntraComm(), 0, CXios::getXiosComm(), contextLeader, 0, &interComm) ;
+       MPI_Intercomm_create(getIntraComm(), 0, CXios::getXiosComm(), contextLeader, 0, &interComm) ;
 
        MPI_Comm_dup(intraComm_, &intraCommClient) ;
@@ -824,5 +862,6 @@
           couplersInFinalized=true ;
           for(auto& couplerOutClient : couplerOutClient_) couplersInFinalized &= isCouplerInContextFinalized(couplerOutClient.second) ; 
-          globalEventLoop() ;
+          if (CThreadManager::isUsingThreads()) yield() ;
+          else globalEventLoop() ;
         } while (!couplersInFinalized) ;
 
@@ -900,25 +939,35 @@
           info(100)<<"DEBUG: context "<<getId()<<" release client reader ok"<<endl ;
         }
+        closeAllFile() ;
       }
       else if (serviceType_==CServicesManager::GATHERER)
       {
-         for(auto& client : writerClientOut_)
-         {
-           client->finalize();
-           bool bufferReleased;
-           do
-           {
-             client->eventLoop();
-             bufferReleased = !client->havePendingRequests();
-           } while (!bufferReleased);
+        CContextClient* client ;
+        CContextServer* server ;
+        
+        for(int n=0; n<writerClientOut_.size() ; n++)
+        {
+          client=writerClientOut_[n] ;
+          server=writerServerOut_[n] ;
+        
+          client->finalize();
+          bool bufferReleased;
+          do
+          {
+            client->eventLoop();
+            bufferReleased = !client->havePendingRequests();
+          } while (!bufferReleased);
            
-           bool notifiedFinalized=false ;
-           do
-           {
-             notifiedFinalized=client->isNotifiedFinalized() ;
-           } while (!notifiedFinalized) ;
-           client->releaseBuffers();
+          bool notifiedFinalized=false ;
+          do
+          {
+            notifiedFinalized=client->isNotifiedFinalized() ;
+          } while (!notifiedFinalized) ;
+          server->releaseBuffers();
+          client->releaseBuffers();
          }
          closeAllFile();
+         writerClientIn_[0]->releaseBuffers();
+         writerServerIn_[0]->releaseBuffers();         
          //ym writerClientIn & writerServerIn not released here ==> to check !!
       }
@@ -957,20 +1006,33 @@
    void CContext::setDefaultServices(void)
    {
-     defaultPoolWriterId_ = CXios::defaultPoolId ;
-     defaultPoolReaderId_ = CXios::defaultPoolId ;
-     defaultPoolGathererId_ = CXios::defaultPoolId ;
-     defaultWriterId_ = CXios::defaultWriterId ;
-     defaultReaderId_ = CXios::defaultReaderId ;
-     defaultGathererId_ = CXios::defaultGathererId ;
-     defaultUsingServer2_ = CXios::usingServer2 ;
+     if (!CXios::isUsingServer())
+     {
+       defaultPoolWriterId_ = CXios::defaultPoolId ;
+       defaultPoolReaderId_ = CXios::defaultPoolId ;
+       defaultPoolGathererId_ = CXios::defaultPoolId ;
+       defaultWriterId_ = "attached" ;
+       defaultReaderId_ = "attached" ;
+       defaultGathererId_ =  "attached" ;
+       defaultUsingServer2_ = false;
+     }
+     else
+     {
+       defaultPoolWriterId_ = CXios::defaultPoolId ;
+       defaultPoolReaderId_ = CXios::defaultPoolId ;
+       defaultPoolGathererId_ = CXios::defaultPoolId ;
+       defaultWriterId_ = CXios::defaultWriterId ;
+       defaultReaderId_ = CXios::defaultReaderId ;
+       defaultGathererId_ = CXios::defaultGathererId ;
+       defaultUsingServer2_ = CXios::usingServer2 ;
      
-     if (!default_pool.isEmpty())  defaultPoolWriterId_ = defaultPoolReaderId_= defaultPoolGathererId_= default_pool ;
-     if (!default_pool_writer.isEmpty()) defaultPoolWriterId_ = default_pool_writer ;
-     if (!default_pool_reader.isEmpty()) defaultPoolReaderId_ = default_pool_reader ;
-     if (!default_pool_gatherer.isEmpty()) defaultPoolGathererId_ = default_pool_gatherer ;
-     if (!default_writer.isEmpty()) defaultWriterId_ = default_writer ;
-     if (!default_reader.isEmpty()) defaultWriterId_ = default_reader ;
-     if (!default_gatherer.isEmpty()) defaultGathererId_ = default_gatherer ;
-     if (!default_using_server2.isEmpty()) defaultUsingServer2_ = default_using_server2 ;
+       if (!default_pool.isEmpty())  defaultPoolWriterId_ = defaultPoolReaderId_= defaultPoolGathererId_= default_pool ;
+       if (!default_pool_writer.isEmpty()) defaultPoolWriterId_ = default_pool_writer ;
+       if (!default_pool_reader.isEmpty()) defaultPoolReaderId_ = default_pool_reader ;
+       if (!default_pool_gatherer.isEmpty()) defaultPoolGathererId_ = default_pool_gatherer ;
+       if (!default_writer.isEmpty()) defaultWriterId_ = default_writer ;
+       if (!default_reader.isEmpty()) defaultWriterId_ = default_reader ;
+       if (!default_gatherer.isEmpty()) defaultGathererId_ = default_gatherer ;
+       if (!default_using_server2.isEmpty()) defaultUsingServer2_ = default_using_server2 ;
+     }
    }
 
Index: XIOS3/trunk/src/node/context.hpp
===================================================================
--- XIOS3/trunk/src/node/context.hpp	(revision 2546)
+++ XIOS3/trunk/src/node/context.hpp	(revision 2547)
@@ -112,4 +112,6 @@
          bool scheduledEventLoop(bool enableEventsProcessing=true) ; 
          void globalEventLoop(void);
+         void yield(void) ;
+         void synchronize(void) ;
 
          // Finalize a context
@@ -368,4 +370,7 @@
         int getIntraCommRank(void) {return intraCommRank_;}
         int getIntraCommSize(void) {return intraCommSize_;}
+      
+      public:
+        shared_ptr<CEventScheduler> getEventScheduler(void) {return eventScheduler_ ;}
       private:
          shared_ptr<CEventScheduler> eventScheduler_ ; //! The local event scheduler for context
Index: XIOS3/trunk/src/node/pool_node.cpp
===================================================================
--- XIOS3/trunk/src/node/pool_node.cpp	(revision 2546)
+++ XIOS3/trunk/src/node/pool_node.cpp	(revision 2547)
@@ -1,4 +1,5 @@
 #include "pool_node.hpp"
 #include "cxios.hpp"
+#include "thread_manager.hpp"
 #include<cmath>
 
@@ -61,5 +62,11 @@
     else ERROR("void CPoolNode::allocateRessources(void)",<<"Pool has no name or id, attributes <id> or <name> must be specified")
     ressourcesManager->createPool(poolId, nbRessources) ;
-    ressourcesManager->waitPoolRegistration(poolId) ;
+    if (CThreadManager::isUsingThreads()) 
+      while(!ressourcesManager->hasPool(CXios::defaultPoolId)) 
+      {
+        CXios::getDaemonsManager()->eventLoop() ;
+        CThreadManager::yield() ;
+      }
+    else ressourcesManager->waitPoolRegistration(poolId) ;
     auto services=this->getAllServiceNodes() ;
     for(auto& service : services) service->allocateRessources(poolId) ;
Index: XIOS3/trunk/src/server.cpp
===================================================================
--- XIOS3/trunk/src/server.cpp	(revision 2546)
+++ XIOS3/trunk/src/server.cpp	(revision 2547)
@@ -25,4 +25,5 @@
 #include "workflow_graph.hpp"
 #include "release_static_allocation.hpp"
+#include "thread_manager.hpp"
 #include <sys/stat.h>
 #include <unistd.h>
@@ -68,5 +69,10 @@
       if (!CXios::usingOasis)
       {
-        if (!is_MPI_Initialized) MPI_Init(NULL, NULL);
+        if (!is_MPI_Initialized) 
+        {
+          int required = MPI_THREAD_SERIALIZED ;
+          int provided ;
+          MPI_Init_thread(NULL,NULL, required, &provided) ;
+        }
        
         // split the global communicator
@@ -99,5 +105,13 @@
       else // using OASIS
       {
-        if (!is_MPI_Initialized) driver_ = new CThirdPartyDriver();
+        
+        if (!is_MPI_Initialized) 
+        {
+          int required = MPI_THREAD_SERIALIZED ;
+          int provided ;
+          MPI_Init_thread(NULL,NULL, required, &provided) ;
+        }
+
+        driver_ = new CThirdPartyDriver();
 
         driver_->getComponentCommunicator( serverComm );
@@ -200,9 +214,28 @@
           {
             ressourcesManager->createPool(CXios::defaultPoolId, nbRessources) ;
-            ressourcesManager->waitPoolRegistration(CXios::defaultPoolId) ;
+            if (CThreadManager::isUsingThreads()) 
+              while(!ressourcesManager->hasPool(CXios::defaultPoolId)) 
+              {
+                daemonsManager->eventLoop() ;
+                CThreadManager::yield() ;
+              }
+            else ressourcesManager->waitPoolRegistration(CXios::defaultPoolId) ;
+          
             servicesManager->createServices(CXios::defaultPoolId, CXios::defaultWriterId, CServicesManager::WRITER,nbRessources,1) ;
-            servicesManager->waitServiceRegistration(CXios::defaultPoolId, CXios::defaultWriterId) ;
+            if (CThreadManager::isUsingThreads()) 
+              while(!servicesManager->hasService(CXios::defaultPoolId, CXios::defaultWriterId,0)) 
+              {
+                daemonsManager->eventLoop() ;
+                CThreadManager::yield() ;
+              }
+            else servicesManager->waitServiceRegistration(CXios::defaultPoolId, CXios::defaultWriterId) ;
+            
             servicesManager->createServicesOnto(CXios::defaultPoolId, CXios::defaultReaderId, CServicesManager::READER, CXios::defaultWriterId) ;
-            servicesManager->waitServiceRegistration(CXios::defaultPoolId, CXios::defaultReaderId) ;
+            if (CThreadManager::isUsingThreads()) 
+            {
+              daemonsManager->eventLoop() ;
+              while(!servicesManager->hasService(CXios::defaultPoolId, CXios::defaultReaderId, 0)) CThreadManager::yield() ;
+            }
+            else servicesManager->waitServiceRegistration(CXios::defaultPoolId, CXios::defaultReaderId) ;
           }
           else
@@ -214,11 +247,39 @@
             if (nbPoolsServer2 == 0) nbPoolsServer2 = nprocsServer;
             ressourcesManager->createPool(CXios::defaultPoolId, nbRessources) ;
-            ressourcesManager->waitPoolRegistration(CXios::defaultPoolId) ;
+            if (CThreadManager::isUsingThreads()) 
+              while(!ressourcesManager->hasPool(CXios::defaultPoolId)) 
+              {
+                daemonsManager->eventLoop() ;
+                CThreadManager::yield() ;
+              }
+            else ressourcesManager->waitPoolRegistration(CXios::defaultPoolId) ;
+
             servicesManager->createServices(CXios::defaultPoolId,  CXios::defaultGathererId, CServicesManager::GATHERER, nprocsGatherer, 1) ;
-            servicesManager->waitServiceRegistration(CXios::defaultPoolId, CXios::defaultGathererId) ;
+            if (CThreadManager::isUsingThreads()) 
+              while(!servicesManager->hasService(CXios::defaultPoolId, CXios::defaultGathererId,0)) 
+              {
+                daemonsManager->eventLoop() ;
+                CThreadManager::yield() ;
+              }
+            else servicesManager->waitServiceRegistration(CXios::defaultPoolId, CXios::defaultGathererId) ;
+
             servicesManager->createServicesOnto(CXios::defaultPoolId, CXios::defaultReaderId, CServicesManager::READER, CXios::defaultGathererId) ;
-            servicesManager->waitServiceRegistration(CXios::defaultPoolId, CXios::defaultReaderId) ;
+            if (CThreadManager::isUsingThreads()) 
+              while(!servicesManager->hasService(CXios::defaultPoolId, CXios::defaultReaderId, 0)) 
+              {
+                daemonsManager->eventLoop() ;
+                CThreadManager::yield() ;
+              }
+            else servicesManager->waitServiceRegistration(CXios::defaultPoolId, CXios::defaultReaderId) ;
+            
             servicesManager->createServices(CXios::defaultPoolId,  CXios::defaultWriterId, CServicesManager::WRITER, nprocsServer, nbPoolsServer2) ;
-            servicesManager->waitServiceRegistration(CXios::defaultPoolId, CXios::defaultWriterId) ;
+            if (CThreadManager::isUsingThreads())
+              for(int i=0; i<nbPoolsServer2; i++)
+                while(!servicesManager->hasService(CXios::defaultPoolId, CXios::defaultWriterId,i)) 
+                {
+                  daemonsManager->eventLoop() ;
+                  CThreadManager::yield() ;
+                }
+            else servicesManager->waitServiceRegistration(CXios::defaultPoolId, CXios::defaultWriterId) ;
           }
         }
@@ -233,9 +294,10 @@
       {
         daemonsManager->eventLoop() ;
+        if (CThreadManager::isUsingThreads()) CThreadManager::yield();
         MPI_Test(&req,&ok,&status) ;
       }
 
 
-      testingEventScheduler() ;
+      //testingEventScheduler() ;
 /*
       MPI_Request req ;
@@ -262,4 +324,5 @@
       {
         finished=daemonsManager->eventLoop() ;
+        if (CThreadManager::isUsingThreads()) CThreadManager::yield() ;
       }
       CTimer::get("XIOS event loop").suspend() ;
Index: XIOS3/trunk/src/transport/context_client.cpp
===================================================================
--- XIOS3/trunk/src/transport/context_client.cpp	(revision 2546)
+++ XIOS3/trunk/src/transport/context_client.cpp	(revision 2547)
@@ -40,11 +40,7 @@
 
       int flag;
-      MPI_Comm_test_inter(interComm, &flag);
-      if (flag) isAttached_=false ;
-      else  isAttached_=true ;
-
-      if (flag) MPI_Comm_remote_size(interComm, &serverSize);
-      else  MPI_Comm_size(interComm, &serverSize);
-
+      
+      MPI_Comm_remote_size(interComm, &serverSize);
+      
       computeLeader(clientRank, clientSize, serverSize, ranksServerLeader, ranksServerNotLeader);
 
Index: XIOS3/trunk/src/transport/context_client.hpp
===================================================================
--- XIOS3/trunk/src/transport/context_client.hpp	(revision 2546)
+++ XIOS3/trunk/src/transport/context_client.hpp	(revision 2547)
@@ -40,5 +40,4 @@
       const std::list<int>& getRanksServerLeader(void) const;
       const std::list<int>& getRanksServerNotLeader(void) const;
-      bool isAttachedModeEnabled() const { return isAttached_ ; } 
       static void computeLeader(int clientRank, int clientSize, int serverSize,
                                 std::list<int>& rankRecvLeader,
@@ -93,5 +92,4 @@
       size_t hashId_ ; //!< hash id on the context client that will be used for context server to identify the remote calling context client.
 
-      bool isAttached_ ;
       CContextServer* associatedServer_ ; //!< The server associated to the pair client/server
   };
Index: XIOS3/trunk/src/transport/context_server.cpp
===================================================================
--- XIOS3/trunk/src/transport/context_server.cpp	(revision 2546)
+++ XIOS3/trunk/src/transport/context_server.cpp	(revision 2547)
@@ -44,13 +44,6 @@
 
     interComm=interComm_;
-    int flag;
-    MPI_Comm_test_inter(interComm,&flag);
-
-    if (flag) attachedMode=false ;
-    else  attachedMode=true ;
+    MPI_Comm_remote_size(interComm,&clientSize_);
     
-    if (flag) MPI_Comm_remote_size(interComm,&clientSize_);
-    else  MPI_Comm_size(interComm,&clientSize_);
-
     SRegisterContextInfo contextInfo ;
     CXios::getContextsManager()->getContextInfo(context->getId(), contextInfo, intraComm) ;
@@ -89,10 +82,3 @@
   }
 
-//! Attached mode is used ?
-//! \return true if attached mode is used, false otherwise
-  bool CContextServer::isAttachedModeEnabled() const
-  {
-    return attachedMode ;
-  }
-
 }
Index: XIOS3/trunk/src/transport/context_server.hpp
===================================================================
--- XIOS3/trunk/src/transport/context_server.hpp	(revision 2546)
+++ XIOS3/trunk/src/transport/context_server.hpp	(revision 2547)
@@ -23,5 +23,4 @@
     CContextServer(CContext* parent,MPI_Comm intraComm,MPI_Comm interComm) ;
     ~CContextServer() {} 
-    bool isAttachedModeEnabled() const ;
     void setAssociatedClient(CContextClient* associatedClient) {associatedClient_=associatedClient ;}
     CContextClient* getAssociatedClient(void) { return associatedClient_ ;}
@@ -41,6 +40,4 @@
       int commSize ;
       int clientSize_ ;
-
-      bool attachedMode ;  //! true if attached mode is enabled otherwise false
 
       CContext* context ;
